# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mrpt_msgs/SingleObjectObservation.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class SingleObjectObservation(genpy.Message):
  _md5sum = "f01d7f64085189fa2ea2feea630b2c0e"
  _type = "mrpt_msgs/SingleObjectObservation"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#int32 INVALID_LANDMARK_ID = -1


float64  range              # Distance, in meters.
float64  yaw                # Angle wrt +Z (rads)
float64  pitch              # Angle wrt +Y (rads)
geometry_msgs/Pose pose_wo  #Pose in world space coordinates
geometry_msgs/Pose pose_so  #Pose in sensor space coordinates
float32[] shape_variables   #Shape variables describing the object
int32    id                 # Landmark ID (or INVALID_LANDMARK_ID if landmarks are not identified)


================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['range','yaw','pitch','pose_wo','pose_so','shape_variables','id']
  _slot_types = ['float64','float64','float64','geometry_msgs/Pose','geometry_msgs/Pose','float32[]','int32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       range,yaw,pitch,pose_wo,pose_so,shape_variables,id

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SingleObjectObservation, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.range is None:
        self.range = 0.
      if self.yaw is None:
        self.yaw = 0.
      if self.pitch is None:
        self.pitch = 0.
      if self.pose_wo is None:
        self.pose_wo = geometry_msgs.msg.Pose()
      if self.pose_so is None:
        self.pose_so = geometry_msgs.msg.Pose()
      if self.shape_variables is None:
        self.shape_variables = []
      if self.id is None:
        self.id = 0
    else:
      self.range = 0.
      self.yaw = 0.
      self.pitch = 0.
      self.pose_wo = geometry_msgs.msg.Pose()
      self.pose_so = geometry_msgs.msg.Pose()
      self.shape_variables = []
      self.id = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_17d().pack(_x.range, _x.yaw, _x.pitch, _x.pose_wo.position.x, _x.pose_wo.position.y, _x.pose_wo.position.z, _x.pose_wo.orientation.x, _x.pose_wo.orientation.y, _x.pose_wo.orientation.z, _x.pose_wo.orientation.w, _x.pose_so.position.x, _x.pose_so.position.y, _x.pose_so.position.z, _x.pose_so.orientation.x, _x.pose_so.orientation.y, _x.pose_so.orientation.z, _x.pose_so.orientation.w))
      length = len(self.shape_variables)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.Struct(pattern).pack(*self.shape_variables))
      _x = self.id
      buff.write(_get_struct_i().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose_wo is None:
        self.pose_wo = geometry_msgs.msg.Pose()
      if self.pose_so is None:
        self.pose_so = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 136
      (_x.range, _x.yaw, _x.pitch, _x.pose_wo.position.x, _x.pose_wo.position.y, _x.pose_wo.position.z, _x.pose_wo.orientation.x, _x.pose_wo.orientation.y, _x.pose_wo.orientation.z, _x.pose_wo.orientation.w, _x.pose_so.position.x, _x.pose_so.position.y, _x.pose_so.position.z, _x.pose_so.orientation.x, _x.pose_so.orientation.y, _x.pose_so.orientation.z, _x.pose_so.orientation.w,) = _get_struct_17d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.shape_variables = s.unpack(str[start:end])
      start = end
      end += 4
      (self.id,) = _get_struct_i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_17d().pack(_x.range, _x.yaw, _x.pitch, _x.pose_wo.position.x, _x.pose_wo.position.y, _x.pose_wo.position.z, _x.pose_wo.orientation.x, _x.pose_wo.orientation.y, _x.pose_wo.orientation.z, _x.pose_wo.orientation.w, _x.pose_so.position.x, _x.pose_so.position.y, _x.pose_so.position.z, _x.pose_so.orientation.x, _x.pose_so.orientation.y, _x.pose_so.orientation.z, _x.pose_so.orientation.w))
      length = len(self.shape_variables)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.shape_variables.tostring())
      _x = self.id
      buff.write(_get_struct_i().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.pose_wo is None:
        self.pose_wo = geometry_msgs.msg.Pose()
      if self.pose_so is None:
        self.pose_so = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 136
      (_x.range, _x.yaw, _x.pitch, _x.pose_wo.position.x, _x.pose_wo.position.y, _x.pose_wo.position.z, _x.pose_wo.orientation.x, _x.pose_wo.orientation.y, _x.pose_wo.orientation.z, _x.pose_wo.orientation.w, _x.pose_so.position.x, _x.pose_so.position.y, _x.pose_so.position.z, _x.pose_so.orientation.x, _x.pose_so.orientation.y, _x.pose_so.orientation.z, _x.pose_so.orientation.w,) = _get_struct_17d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.shape_variables = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (self.id,) = _get_struct_i().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_17d = None
def _get_struct_17d():
    global _struct_17d
    if _struct_17d is None:
        _struct_17d = struct.Struct("<17d")
    return _struct_17d
_struct_i = None
def _get_struct_i():
    global _struct_i
    if _struct_i is None:
        _struct_i = struct.Struct("<i")
    return _struct_i
