# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mrpt_msgs/GetCMGraphRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GetCMGraphRequest(genpy.Message):
  _md5sum = "8335f3b12a461e409473fe2603756eb1"
  _type = "mrpt_msgs/GetCMGraphRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Compute and return a condensed measurements graph
# Service is currently used in mrpt_graphslam_2d application
# Returned graph should, at all cost contain the specified nodes

uint64[] node_ids
"""
  __slots__ = ['node_ids']
  _slot_types = ['uint64[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       node_ids

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GetCMGraphRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.node_ids is None:
        self.node_ids = []
    else:
      self.node_ids = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.node_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.Struct(pattern).pack(*self.node_ids))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.node_ids = s.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.node_ids)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.node_ids.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.node_ids = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mrpt_msgs/GetCMGraphResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import mrpt_msgs.msg
import std_msgs.msg

class GetCMGraphResponse(genpy.Message):
  _md5sum = "9186af82e37323e85b041d4db503e0a4"
  _type = "mrpt_msgs/GetCMGraphResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """mrpt_msgs/NetworkOfPoses cm_graph


================================================================================
MSG: mrpt_msgs/NetworkOfPoses
# Represents a 2D/3D Directed Graph of Constraints
#
# Graph consists of:
# - NodeIDs with their corresponding poses
# - Directed Constraints that connect 2 nodes with each other
# - Root node marking the start of the graph

uint64 root
NodeIDWithPoseVec nodes
GraphConstraint[] constraints

================================================================================
MSG: mrpt_msgs/NodeIDWithPoseVec
# Vector of NodeIDWithPose msgs

NodeIDWithPose[] vec


================================================================================
MSG: mrpt_msgs/NodeIDWithPose
# NodeID along with its corresponding 2D/3D pose estimation.
# Message also contains the following optional fields:
# - str_ID: string identifier of the robot agent that initially registered this node in
# its graph
# - node_id_loc: ID of the current node in the graph it was initially registered in.
#
# note: Additional fields correspond to the fields of the
# mrpt::graphs::detail::TMRSlamNodeAnnotations struct
#
# Currently used in the mrpt_graphslam_2d ROS application.

uint64 node_id
geometry_msgs/Pose pose

std_msgs/String str_id
uint64 node_id_loc

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: std_msgs/String
string data

================================================================================
MSG: mrpt_msgs/GraphConstraint
# Graph constraint that connects 2 nodes
#
# Currently used in the mrpt_graphslam_2d ROS application.

uint64 node_id_from
uint64 node_id_to
geometry_msgs/PoseWithCovariance constraint

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance
"""
  __slots__ = ['cm_graph']
  _slot_types = ['mrpt_msgs/NetworkOfPoses']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       cm_graph

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GetCMGraphResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.cm_graph is None:
        self.cm_graph = mrpt_msgs.msg.NetworkOfPoses()
    else:
      self.cm_graph = mrpt_msgs.msg.NetworkOfPoses()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.cm_graph.root
      buff.write(_get_struct_Q().pack(_x))
      length = len(self.cm_graph.nodes.vec)
      buff.write(_struct_I.pack(length))
      for val1 in self.cm_graph.nodes.vec:
        _x = val1.node_id
        buff.write(_get_struct_Q().pack(_x))
        _v1 = val1.pose
        _v2 = _v1.position
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = _v1.orientation
        _x = _v3
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v4 = val1.str_id
        _x = _v4.data
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_id_loc
        buff.write(_get_struct_Q().pack(_x))
      length = len(self.cm_graph.constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.cm_graph.constraints:
        _x = val1
        buff.write(_get_struct_2Q().pack(_x.node_id_from, _x.node_id_to))
        _v5 = val1.constraint
        _v6 = _v5.pose
        _v7 = _v6.position
        _x = _v7
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v8 = _v6.orientation
        _x = _v8
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_get_struct_36d().pack(*_v5.covariance))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cm_graph is None:
        self.cm_graph = mrpt_msgs.msg.NetworkOfPoses()
      end = 0
      start = end
      end += 8
      (self.cm_graph.root,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cm_graph.nodes.vec = []
      for i in range(0, length):
        val1 = mrpt_msgs.msg.NodeIDWithPose()
        start = end
        end += 8
        (val1.node_id,) = _get_struct_Q().unpack(str[start:end])
        _v9 = val1.pose
        _v10 = _v9.position
        _x = _v10
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v11 = _v9.orientation
        _x = _v11
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v12 = val1.str_id
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v12.data = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v12.data = str[start:end]
        start = end
        end += 8
        (val1.node_id_loc,) = _get_struct_Q().unpack(str[start:end])
        self.cm_graph.nodes.vec.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cm_graph.constraints = []
      for i in range(0, length):
        val1 = mrpt_msgs.msg.GraphConstraint()
        _x = val1
        start = end
        end += 16
        (_x.node_id_from, _x.node_id_to,) = _get_struct_2Q().unpack(str[start:end])
        _v13 = val1.constraint
        _v14 = _v13.pose
        _v15 = _v14.position
        _x = _v15
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v16 = _v14.orientation
        _x = _v16
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 288
        _v13.covariance = _get_struct_36d().unpack(str[start:end])
        self.cm_graph.constraints.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.cm_graph.root
      buff.write(_get_struct_Q().pack(_x))
      length = len(self.cm_graph.nodes.vec)
      buff.write(_struct_I.pack(length))
      for val1 in self.cm_graph.nodes.vec:
        _x = val1.node_id
        buff.write(_get_struct_Q().pack(_x))
        _v17 = val1.pose
        _v18 = _v17.position
        _x = _v18
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v19 = _v17.orientation
        _x = _v19
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _v20 = val1.str_id
        _x = _v20.data
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.node_id_loc
        buff.write(_get_struct_Q().pack(_x))
      length = len(self.cm_graph.constraints)
      buff.write(_struct_I.pack(length))
      for val1 in self.cm_graph.constraints:
        _x = val1
        buff.write(_get_struct_2Q().pack(_x.node_id_from, _x.node_id_to))
        _v21 = val1.constraint
        _v22 = _v21.pose
        _v23 = _v22.position
        _x = _v23
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v24 = _v22.orientation
        _x = _v24
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_v21.covariance.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.cm_graph is None:
        self.cm_graph = mrpt_msgs.msg.NetworkOfPoses()
      end = 0
      start = end
      end += 8
      (self.cm_graph.root,) = _get_struct_Q().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cm_graph.nodes.vec = []
      for i in range(0, length):
        val1 = mrpt_msgs.msg.NodeIDWithPose()
        start = end
        end += 8
        (val1.node_id,) = _get_struct_Q().unpack(str[start:end])
        _v25 = val1.pose
        _v26 = _v25.position
        _x = _v26
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v27 = _v25.orientation
        _x = _v27
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _v28 = val1.str_id
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v28.data = str[start:end].decode('utf-8', 'rosmsg')
        else:
          _v28.data = str[start:end]
        start = end
        end += 8
        (val1.node_id_loc,) = _get_struct_Q().unpack(str[start:end])
        self.cm_graph.nodes.vec.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cm_graph.constraints = []
      for i in range(0, length):
        val1 = mrpt_msgs.msg.GraphConstraint()
        _x = val1
        start = end
        end += 16
        (_x.node_id_from, _x.node_id_to,) = _get_struct_2Q().unpack(str[start:end])
        _v29 = val1.constraint
        _v30 = _v29.pose
        _v31 = _v30.position
        _x = _v31
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v32 = _v30.orientation
        _x = _v32
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 288
        _v29.covariance = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=36)
        self.cm_graph.constraints.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Q = None
def _get_struct_2Q():
    global _struct_2Q
    if _struct_2Q is None:
        _struct_2Q = struct.Struct("<2Q")
    return _struct_2Q
_struct_36d = None
def _get_struct_36d():
    global _struct_36d
    if _struct_36d is None:
        _struct_36d = struct.Struct("<36d")
    return _struct_36d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_Q = None
def _get_struct_Q():
    global _struct_Q
    if _struct_Q is None:
        _struct_Q = struct.Struct("<Q")
    return _struct_Q
class GetCMGraph(object):
  _type          = 'mrpt_msgs/GetCMGraph'
  _md5sum = 'd378f4867b29142fec7dac3e8b8440a2'
  _request_class  = GetCMGraphRequest
  _response_class = GetCMGraphResponse
