// Auto-generated. Do not edit!

// (in-package mrpt_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class SingleObjectObservation {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.range = null;
      this.yaw = null;
      this.pitch = null;
      this.pose_wo = null;
      this.pose_so = null;
      this.shape_variables = null;
      this.id = null;
    }
    else {
      if (initObj.hasOwnProperty('range')) {
        this.range = initObj.range
      }
      else {
        this.range = 0.0;
      }
      if (initObj.hasOwnProperty('yaw')) {
        this.yaw = initObj.yaw
      }
      else {
        this.yaw = 0.0;
      }
      if (initObj.hasOwnProperty('pitch')) {
        this.pitch = initObj.pitch
      }
      else {
        this.pitch = 0.0;
      }
      if (initObj.hasOwnProperty('pose_wo')) {
        this.pose_wo = initObj.pose_wo
      }
      else {
        this.pose_wo = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('pose_so')) {
        this.pose_so = initObj.pose_so
      }
      else {
        this.pose_so = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('shape_variables')) {
        this.shape_variables = initObj.shape_variables
      }
      else {
        this.shape_variables = [];
      }
      if (initObj.hasOwnProperty('id')) {
        this.id = initObj.id
      }
      else {
        this.id = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SingleObjectObservation
    // Serialize message field [range]
    bufferOffset = _serializer.float64(obj.range, buffer, bufferOffset);
    // Serialize message field [yaw]
    bufferOffset = _serializer.float64(obj.yaw, buffer, bufferOffset);
    // Serialize message field [pitch]
    bufferOffset = _serializer.float64(obj.pitch, buffer, bufferOffset);
    // Serialize message field [pose_wo]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose_wo, buffer, bufferOffset);
    // Serialize message field [pose_so]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose_so, buffer, bufferOffset);
    // Serialize message field [shape_variables]
    bufferOffset = _arraySerializer.float32(obj.shape_variables, buffer, bufferOffset, null);
    // Serialize message field [id]
    bufferOffset = _serializer.int32(obj.id, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SingleObjectObservation
    let len;
    let data = new SingleObjectObservation(null);
    // Deserialize message field [range]
    data.range = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [yaw]
    data.yaw = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [pitch]
    data.pitch = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [pose_wo]
    data.pose_wo = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose_so]
    data.pose_so = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [shape_variables]
    data.shape_variables = _arrayDeserializer.float32(buffer, bufferOffset, null)
    // Deserialize message field [id]
    data.id = _deserializer.int32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += 4 * object.shape_variables.length;
    return length + 144;
  }

  static datatype() {
    // Returns string type for a message object
    return 'mrpt_msgs/SingleObjectObservation';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f01d7f64085189fa2ea2feea630b2c0e';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    #int32 INVALID_LANDMARK_ID = -1
    
    
    float64  range              # Distance, in meters.
    float64  yaw                # Angle wrt +Z (rads)
    float64  pitch              # Angle wrt +Y (rads)
    geometry_msgs/Pose pose_wo  #Pose in world space coordinates
    geometry_msgs/Pose pose_so  #Pose in sensor space coordinates
    float32[] shape_variables   #Shape variables describing the object
    int32    id                 # Landmark ID (or INVALID_LANDMARK_ID if landmarks are not identified)
    
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SingleObjectObservation(null);
    if (msg.range !== undefined) {
      resolved.range = msg.range;
    }
    else {
      resolved.range = 0.0
    }

    if (msg.yaw !== undefined) {
      resolved.yaw = msg.yaw;
    }
    else {
      resolved.yaw = 0.0
    }

    if (msg.pitch !== undefined) {
      resolved.pitch = msg.pitch;
    }
    else {
      resolved.pitch = 0.0
    }

    if (msg.pose_wo !== undefined) {
      resolved.pose_wo = geometry_msgs.msg.Pose.Resolve(msg.pose_wo)
    }
    else {
      resolved.pose_wo = new geometry_msgs.msg.Pose()
    }

    if (msg.pose_so !== undefined) {
      resolved.pose_so = geometry_msgs.msg.Pose.Resolve(msg.pose_so)
    }
    else {
      resolved.pose_so = new geometry_msgs.msg.Pose()
    }

    if (msg.shape_variables !== undefined) {
      resolved.shape_variables = msg.shape_variables;
    }
    else {
      resolved.shape_variables = []
    }

    if (msg.id !== undefined) {
      resolved.id = msg.id;
    }
    else {
      resolved.id = 0
    }

    return resolved;
    }
};

module.exports = SingleObjectObservation;
